
; change the path here
	incdir	sources:other/flashtro/cracktro_a1/



; Simple Flashtro Intro! No (c)ode by aLpHa oNe!
; ==============================================
;
; fixed by StingRay, should work correctly on all amigas now
; fixed: proper startup/restore, interrupt works with VBR in fastram now...
; no more messing around with system interrupts in the vbi anymore, if
; you take over the hardware, you should forget about the system!
; if you want systeminterrupts, go and code a systemfriendly intro else
; disable them! if you have sex with your gf you wouldn't like someone
; opening the door to watch what you're doing, would you?
;
; fixed replayroutine to work on 68000, bra.l is an 68020+ instruction!
; on a sidenote, the module was missing in the archive so I've added
; a "classic" one now. :)

; also optimized the sinescroller a bit, why set modulos/masks ect. in
; the loop when they don't change? removed them from the innerloop.
;
; have fun, greetings to all at flashtro and aLpHa oNe for coding this
; intro.

	section	flashtro,code_c

;	org $60000		

intro:
	include	startup.i

MAIN	








;	move.w #$4000,$dff096
;	move.w #$83e0,$dff096	; activate Copper/Blitter/Sprite DMA
;	move.l 4.w,a6
;	lea gfxlib(pc),a1	; Adress of gfxlib string to a1
;	jsr -408(a6)		; Call OpenLibrary()
;	move.l d0,gfxbase	; Save base of graphics.library


	move.l #$80000000,a1	; White Sprite
	move.l #$00008000,a2	; Gray Sprite
	move.l #$80008000,a3	; Dark Gray Sprite
	lea sprites(pc),a0	; Create spritedatas
	lea sprites2(pc),a4	; 
	moveq #102-1,d2		; Members in spritelist
	moveq #0,d1		; First Sprite X
	moveq #40,d3		; First Sprite X second spritelist
	move.b #$30,d0		; First Sprite Y	
dospr:	move.b d0,(a0)+		; Insert in list
	move.b d1,(a0)+		; Sprite X
	addq.b #1,d0		; Y+1
	move.b d0,(a0)+		; Sprite Y + Height 
	move.b #0,(a0)+		; Dummy
	move.l a1,(a0)+ 	; The main spritedata
	move.b d0,(a4)+
	move.b d3,(a4)+
	addq.b #1,d0		; Y+1
	move.b d0,(a4)+
	move.b #0,(a4)+
	move.l a1,(a4)+
	exg.l a1,a2		; Swap spritedatas
	exg.l a2,a3		;
	add.w d2,d1		; Add X Value
	add.w d1,d3		; 
	dbf d2,dospr		; Loop

	lea logo(pc),a0		; Adress of Logo (top part)
	lea logo+70*40(pc),a2	; Adress of Logo (bottom part)
	lea logotop(pc),a1	; Adress of Bitplaneptr to Top Logo in cop
	lea logobottom(pc),a3	; Adress of Bitplaneptr to Bottom Logo in cop
	moveq #4-1,d2		; 4 Bitplanes to set
setbpl:	move.l a0,d0		; Set bitplanesptr in copperlist
	move.l a2,d1
	move.w d0,6(a1)
	move.w d1,6(a3)
	swap d0
	swap d1
	move.w d0,2(a1)
	move.w d1,2(a3)
	add.l #(320/8)*105,a0	; Pointer to next bitplane in Top Logo
	add.l #(320/8)*105,a2	; Pointer to next bitplane in Bottom Logo
	addq.l #8,a1
	addq.l #8,a3
	dbf d2,setbpl

	move.l #plane,d0	; Logo for typer into copperlist
	move.w d0,bplptr+14
	swap d0
	move.w d0,bplptr+10

	move.l #sprites,d0	; Set Address of our spritelist in cop
	move.l #sprites2,d1	
	move.w d0,spriteadr+6
	move.w d1,spriteadr+14
	swap d0
	swap d1
	move.w d0,spriteadr+2
	move.w d1,spriteadr+10

	lea typer(pc),a0
	moveq #6,d0
	moveq #20,d1
	bsr.w txtout

	jsr init_music

;	move.l $6c.w,out+2	; Save old interruptptr
;	move.l #newirq,$6c.w	; Set new interruptroutine

	lea	newirq(pc),a0
	move.l	a0,VBIptr-newirq(a0)

	move.l #cop,$dff080	; Set new copperlist

mouse:	btst #6,$bfe001		; Only a mouseloop here, all neccessary
	bne.b mouse		; stuff is handled in new interrupt routine

;	move.l 4.w,a6		; Get base of exec lib
;	move.l out+2(pc),$6c.w	; Restore old interruptptr
;	move.l gfxbase(pc),a1	; Base of graphics.library to a1
;	move.l 38(a1),$dff080	; Restore old copperlist
;	jsr -414(a6)		; Call CloseLibrary()
;	jsr -138(a6)		; Permit Multitasking
	jsr end_music
	moveq #0,d0		; Over..
	rts			; and out!

;-------------------------------------------------------------------------
newirq:	movem.l d0-a6,-(a7)		; Save registers

	lea $dff000,a6			; Customchipbase to a6

	move.l curpl(pc),a0		; Double Buffering
	move.l curpl+4(pc),a1	
	exg.l a0,a1		
	move.l a0,curpl
	move.l a1,curpl+4	

	move.l a0,d0			; Get address of actual bitplane
	move.w d0,bplptr+6		; ...and set up bitplaneregs
	swap d0				; in copperlist
	move.w d0,bplptr+2		;

wbl:	btst #14,$2(a6)			; Use blitter to clear bitplane
	bne.b wbl		
	move.l #$01000000,$40(a6)
	move.l #$0,$64(a6)
	move.l a1,$dff054
	move.w #140*64+25,$dff058

	subq.b #1,scrdelay		; Already scrolled a full char?
	bne.b scroll			; No, keep on scrolling
	move.b #16,scrdelay		; Otherwise set counter to 16
					; coz we have a 16x16 font ;)
	move.l textptr(pc),a0		; Get Pointer to current textletter
	bsr.w print			; Print the letter
	addq.l #1,textptr		; Increase Textptr to next letter
scroll:	btst #14,$2(a6)			; Blitter ready to work?
	bne.b scroll			; No, keep on waiting

	move.l #scrpl,$50(a6)		; Source A
	move.l #scrpl-2,$54(a6)		; Destination D
	move.l #$f9f00000,$40(a6)	; Set Blittercontrolreg	
	move.l #$ffffffff,$44(a6)	; Maskbits
	move.l #$0,$64(a6)		; Modulo for Source A and Dest D
	move.w #16*64+25,$58(a6)	; Scroll a range of 16 x 400 pixels

	lea sine(pc),a5			; Adress of sinetable to a5
	add.l sineadd(pc),a5		; Add our counter
	cmp.l #sineend,a5		; End of sinetable reached ?
	bne.w .main			; Nah, go on...
	lea sine(pc),a5			; Otherwise sinestart to a5 again
	move.l #0,sineadd		; Clear sinecounter
.main:	moveq #21-1,d7			; Our aim is to blit 21 16x16 blocks
					; from the scroller on the background
					; bitplane to front screen
	lea scrpl(pc),a0		; Adress of our background-bitplane
					; with standard scroll to A0
	move.l curpl+4(pc),a1		; Current Bitplane to work on to A1
	add.l #4,a1			; Move 32 pixels to the right ;)


; all fixed parameters here
	btst	#6,$2(a6)
.wblit	btst	#6,$2(a6)
	bne.b	.wblit
	move.w #48,$62(a6)		; Modulo Source B
	move.w #48,$64(a6)		; Modulo Source A
	move.w #48,$66(a6)		; Modulo Destination D
	move.w #$ffff,$46(a6)		; Maskbits
	move.l #$0dfc0000,$40(a6)	; Set Blittercontrolreg

sinesc:	move.l #$c000,d3		; Modulo = %11000000
	moveq #8-1,d6			; Blit one 16x16 block 8 times with
					; shifting mask

wblit:	btst #14,$2(a6)			; Blitter ready to work?
	bne.b wblit			; No, keep on waiting
	move.l a1,a2			; Current Bitplane to A2
	add.l (a5)+,a2			; Add sine to Bitplaneptr
	cmp.l #sineend,a5		; End of sine reached?
	bne.b sineok			; Nah, go on...
	lea sine(pc),a5			; Address Sinetablestart to A5 again
sineok:	move.l a0,$50(a6)		; Source A
	move.l a2,$4c(a6)		; Source B
	move.l a2,$54(a6)		; Destination D
;	move.l #$0dfc0000,$40(a6)	; Set Blittercontrolreg
	move.w d3,$44(a6)		; Maskbits
;	move.w #$ffff,$46(a6)		; Maskbits
;	move.w #48,$62(a6)		; Modulo Source B
;	move.w #48,$64(a6)		; Modulo Source A
;	move.w #48,$66(a6)		; Modulo Destination D
	move.w #16*64+1,$58(a6)		; Blit a 16x16 Block
	ror.w #2,d3			; Shift current mask
	dbf d6,wblit			; Continue blitting...
	addq.l #2,a0			; Pointer to next 16x16 blocks
	addq.l #2,a1			; on source and destination
	dbf d7,sinesc			; Loop....

	add.l #16,sineadd		; Increase sinetablecounter

ups:	moveq #34-1,d0			; The Sprite Movement
	lea sprites+1(pc),a0
	lea sprites2+1(pc),a1
movesp:	subq.b #3,(a0)
	subq.b #2,8(a0)
	subq.b #1,16(a0)
	subq.b #3,(a1)
	subq.b #2,8(a1)
	subq.b #1,16(a1)
	add.l #24,a0
	add.l #24,a1
	dbf d0,movesp

	jsr play_music

	movem.l (a7)+,d0-a6		; Restore registers
	rts
	
;out:	jmp	$00000000		; Continue standard interrupt routine

;-------------------------------------------------------------------------

; Routine which prints one single letter to a fixed point on bitplane.
; A0 = ptr to text / Used for scroller

print:	move.b (a0),d3		; Get current letter
	tst.b d3		; End of text reached?
	bne.b noend		; Nah, continue
	move.l #text,textptr	; Otherwise set pointer to textstart again
	move.b text(pc),d3	; Get first letter
noend:	lea chartab(pc),a1	; Adress of chartab to a1
	moveq #0,d2		; Counter
search:	cmp.b (a1,d2),d3	; Find letter in chartab
	beq.b foundit		; Letter found? Go on...
	addq.l #1,d2		; ..else increase counter
	bra.b search		; and continue searching
foundit:lsl.l #1,d2		; counter*2 = correct offset to charbuffer
	lea chars(pc),a3	; Address of chars to a3
	add.l d2,a3		; + offset to correct letter
	lea scrpl+48(pc),a2	; Address of scrollplane + 48 (right side)
	moveq #15-1,d2		; Height of chars (-1 coz we use dbf loop)
copy:	move.w (a3),(a2)	; Copy the letter
	add.l #80,a3		; Fontplane has a width of 640 pix (80 bytes)
	add.l #50,a2		; Bitplane has a width of 400 pix (50 bytes)
	dbf d2,copy		;
outy:	rts			; Return to where we came from ;)

; Little Textout-Routine, not optimised, just for explanation
; A0 = ptr to text, D0 = Start X Value, D1 = Start Y Value

txtout:	move.b (a0)+,d3		; Get current letter
	cmp.b #1,d3		; Check for newline? 
	bne.b nopy		; Nah? Continue...
	moveq #6,d0		; Otherwise.., X Value = 6 again and
	add.l #11,d1		; Y Value + 11
	bra.b txtout		; Start from beginning
nopy:	tst.b d3		; End of text reached?
	beq.b later		; Okay, quit print routine
	lea chartab2(pc),a1	; Adress of chartab to a1
	moveq #0,d2		; Counter
find:	cmp.b (a1,d2),d3	; Find letter in chartab
	beq.b found		; Letter found? Go on...
	addq.l #1,d2		; ..else increase counter
	bra.b find		; and continue searching
found:	lea chars2(pc),a3	; Address of chars to a3
	add.l d2,a3		; + offset to correct letter
	lea plane(pc),a2	; Address of bitplane to a2
	move.l d1,d2		; Current Y Value to d2
	muls.w #50,d2		; Multiply Y Value by 40...
	add.l d0,d2		; ... + X Value 	
	add.l d2,a2		; a2 now points to correct x/y position
	moveq #10-1,d2		; Height of chars (-1 coz we use dbf loop)
ccopy:	move.b (a3),(a2)	; Copy the letter
	add.l #50,a2		; 
	add.l #40,a3		; 
	dbf d2,ccopy		;
	addq.l #1,d0		; Increase X Value
	bra.b txtout		; Continue with next letter
later:	rts			; Return to where we came from ;)

; Stuff
; *****

cop:		dc.w	$0106,$0000,$01fc,$0000		; AGA compatible
		dc.w	$008e,$1a63,$0090,$2cc1		; Setting up display,
		dc.w	$0092,$0038,$0094,$00d0		; modulo and so on
		dc.w	$0102,$0000,$0104,$0000
		dc.w	$0106,$0000,$0108,$0000
		dc.w	$010a,$0000
spriteadr:	dc.w	$0120,$0000,$0122,$0000		; Clear spriteptrs
		dc.w	$0124,$0000,$0126,$0000
		dc.w	$0128,$0000,$012a,$0000
		dc.w	$012c,$0000,$012e,$0000
		dc.w	$0130,$0000,$0132,$0000
		dc.w	$0134,$0000,$0136,$0000
		dc.w	$0138,$0000,$013a,$0000
		dc.w	$013c,$0000,$013e,$0000
		dc.w	$0100,$0200			; No Bitplane

		dc.w	$01a2,$0eef,$01a4,$099a		; Spritecolor
		dc.w	$01a6,$0556
		dc.w	$01a8,$0eef,$01aa,$099a
		dc.w	$01ac,$0556

		dc.w	$300f,$fffe,$0100,$4200		; Set 4 Bpl
logotop:	dc.w	$00e0,$0000,$00e2,$0000		; Top Logo
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	$00e8,$0000,$00ea,$0000
		dc.w	$00ec,$0000,$00ee,$0000
		dc.w	$0180,$0000,$0182,$0fff		; Logocolors
		dc.w	$0184,$0cee,$0186,$0034
		dc.w	$0188,$0034,$018a,$0023
		dc.w	$018c,$0002,$018e,$06bc
		dc.w	$0190,$0157,$0192,$08cd
		dc.w	$0194,$0045,$0196,$0079
		dc.w	$0198,$039b,$019a,$0068
		dc.w	$019c,$0057,$019e,$028b

		dc.w	$700f,$fffe,$0100,$0200		; Deactivate Bitplanes

		dc.w	$0092,$0020,$0094,$00d8		; New Display values
		dc.w	$0108,$0002,$010a,$0002		; New Modulo 

		dc.w	$780f,$fffe,$0100,$2200		; Set 1 Bpl for Sine
bplptr:		dc.w	$00e0,$0000,$00e2,$0000		; Adress of bpl
		dc.w	$00e4,$0000,$00e6,$0000		; Adress of bpl

		dc.w	$0184,$0fff,$0186,$0fff		; Typercolors
		
		dc.w	$0182,$045a			; Color Cycling
		dc.w	$850f,$fffe,$0182,$056b		; for Sinescroll
		dc.w	$8a0f,$fffe,$0182,$067c
		dc.w	$900f,$fffe,$0182,$078d
		dc.w	$950f,$fffe,$0182,$089e
		dc.w	$9a0f,$fffe,$0182,$09af
		dc.w	$a00f,$fffe,$0182,$0abf
		dc.w	$a50f,$fffe,$0182,$0bcf
		dc.w	$aa0f,$fffe,$0182,$0cdf
		dc.w	$b00f,$fffe,$0182,$0def
		dc.w	$b50f,$fffe,$0182,$0eff
		dc.w	$ba0f,$fffe,$0182,$0fff
		dc.w	$c00f,$fffe,$0182,$0eff
		dc.w	$c50f,$fffe,$0182,$0def
		dc.w	$ca0f,$fffe,$0182,$0cdf
		dc.w	$d00f,$fffe,$0182,$0bcf
		dc.w	$d50f,$fffe,$0182,$0abf
		dc.w	$da0f,$fffe,$0182,$09af
		dc.w	$e00f,$fffe,$0182,$089e
		dc.w	$e50f,$fffe,$0182,$078d
		dc.w	$ea0f,$fffe,$0182,$067c
		dc.w	$f00f,$fffe,$0182,$056b
		dc.w	$f50f,$fffe,$0182,$045a

		dc.w	$ffdf,$fffe,$050f,$fffe		; Change Display again
		dc.w	$0092,$0038,$0094,$00d0		; and modulo values
		dc.w	$0108,$0000,$010a,$0000		;
		dc.w	$070f,$fffe,$0100,$4200		; Set 4 bpls again
logobottom:	dc.w	$00e0,$0000,$00e2,$0000		; Bottom Logo
		dc.w	$00e4,$0000,$00e6,$0000
		dc.w	$00e8,$0000,$00ea,$0000
		dc.w	$00ec,$0000,$00ee,$0000
		dc.w	$0182,$0fff
		dc.w	$0184,$0cee,$0186,$0034

		dc.w	$270f,$fffe,$0100,$0200		; bpls off!

		dc.w	$ffff,$fffe			; End of copperlist

scrdelay:	dc.b	16,0				; Scrollcounter

textptr:	dc.l	text				; Ptr to our text

typer:		dc.b	"              * flashtro *",1
		dc.b	"       cracked for your pleasure:",1
		dc.b	1
		dc.b	"       the game from the company",1
		dc.b	1
		dc.b	"             see ya lateron!",0

text:		dc.b	"* flashtro.com * presents a "
		dc.b	"two-pixel sinescroll coded f"
		dc.b	"or the new tutorial sourceco"
		dc.b	"de section.                 "
		dc.b	0
		
		even

chartab: 	dc.b 	"abcdefghijklmnopqrstuvwxyz"	; chars as they appear
		dc.b 	"O<=>?#-./()*! "		; in our charbitplane
							; for scroller

chartab2: 	dc.b 	"abcdefghijklmnopqrstuvwxyz"	; chars as they appear
		dc.b 	".:!O#$%* BCDE"			; in our charbitplane
							; for typer

		even

chars:		incbin	"chars.raw"		; The chars in 640x16
							; raw bitplane format
							; 80 bytes each row

chars2:		incbin	"coolfont.raw"	; The chars in 320x16
							; for the typer

		blk.b	50,0				; Some spare bytes
scrpl:		blk.b	17*50,0				; Little bitplane 
							; only for standard
							; scroller, not visible
							; on screen

		even
		
sineadd:	dc.l	0

sine:		incbin	"sine"
sineend:

curpl:		dc.l plane1,plane2

gfxlib:		dc.b	"graphics.library",0,0


gfxbase:	dc.l	0

sprites:	blk.w	102*4,0				; space for sprites
		dc.w	0,0

sprites2:	blk.w	102*4,0				; space for sprites
		dc.w	0,0

logo:		incbin "logo.raw"
plane:		blk.b	150*50,0			; for typer
plane1:		blk.b	150*50,0			; for sinescroll
plane2:		blk.b	150*50,0			; 2 coz doublebuf

*********************************************************
**  Amiga FUTURE COMPOSER   V1.4   Replay routine  **
*********************************************************

;Doesn't work with V1.0 - V1.3 modules !!

PLAY_MUSIC:
	bra.w PLAY

END_MUSIC:
	clr.w onoff
	clr.l $dff0a6
	clr.l $dff0b6
	clr.l $dff0c6
	clr.l $dff0d6
	move.w #$000f,$dff096
	bclr #1,$bfe001
	rts

INIT_MUSIC:
	move.w #1,onoff
	bset #1,$bfe001
	lea modul,a0
	lea 180(a0),a1
	move.l a1,SEQpoint
	move.l a0,a1
	add.l 8(a0),a1
	move.l a1,PATpoint
	move.l a0,a1
	add.l 16(a0),a1
	move.l a1,FRQpoint
	move.l a0,a1
	add.l 24(a0),a1
	move.l a1,VOLpoint
	move.l 4(a0),d0
	divu #13,d0

	lea 40(a0),a1
	lea SOUNDINFO+4(pc),a2
	moveq #10-1,d1
initloop:
	move.w (a1)+,(a2)+
	move.l (a1)+,(a2)+
	adda.w #10,a2
	dbf d1,initloop
	move.l a0,d1
	add.l 32(a0),d1
	lea SOUNDINFO(pc),a3
	move.l d1,(a3)+
	moveq #9-1,d3
	moveq #0,d2
initloop1:
	move.w (a3),d2
	add.l d2,d1
	add.l d2,d1
	addq.l #2,d1
	adda.w #12,a3
	move.l d1,(a3)+
	dbf d3,initloop1

	lea 100(a0),a1
	lea SOUNDINFO+[10*16](pc),a2
	move.l a0,a3
	add.l 36(a0),a3

	moveq #80-1,d1
	moveq #0,d2
initloop2:
	move.l a3,(a2)+
	move.b (a1)+,d2
	move.w d2,(a2)+
	clr.w (a2)+
	move.w d2,(a2)+
	addq.w #6,a2
	add.w d2,a3
	add.w d2,a3
	dbf d1,initloop2
	
	move.l SEQpoint(pc),a0
	moveq #0,d2
	move.b 12(a0),d2		;Get replay speed
	bne.s speedok
	move.b #3,d2			;Set default speed
	speedok:
	move.w d2,respcnt		;Init repspeed counter
	move.w d2,repspd
INIT2:
	clr.w audtemp
	move.w #$000f,$dff096		;Disable audio DMA
	move.w #$0780,$dff09a		;Disable audio IRQ
	moveq #0,d7
	mulu #13,d0
	moveq #4-1,d6			;Number of soundchannels-1
	lea V1data(pc),a0		;Point to 1st voice data area
	lea silent(pc),a1
	lea Chandata(pc),a2
initloop3:
	move.l a1,10(a0)
	move.l a1,18(a0)
	clr.w 4(a0)
	move.w #$000d,6(a0)
	clr.w 8(a0)
	clr.l 14(a0)
	move.b #$01,23(a0)
	move.b #$01,24(a0)
	clr.b 25(a0)
	clr.l 26(a0)
	clr.w 30(a0)
	clr.l 38(a0)
	clr.w 42(a0)
	clr.l 44(a0)
	clr.l 48(a0)
	clr.w 56(a0)
	moveq #$00,d3
	move.w (a2)+,d1
	move.w (a2),d3
	divu #$0003,d3
	moveq #0,d4
	bset d3,d4
	move.w d4,32(a0)
	move.w (a2)+,d3
	andi.l #$00ff,d3
	andi.l #$00ff,d1
	lea $dff0a0,a6
	add.w d1,a6
	move.l #$0000,(a6)
	move.w #$0100,4(a6)
	move.w #$0000,6(a6)
	move.w #$0000,8(a6)
	move.l a6,60(a0)
	move.l SEQpoint(pc),(a0)
	move.l SEQpoint(pc),52(a0)
	add.l d0,52(a0)
	add.l d3,52(a0)
	add.l d7,(a0)
	add.l d3,(a0)
	move.l (a0),a3
	move.b (a3),d1
	andi.l #$00ff,d1
	lsl.w #6,d1
	move.l PATpoint(pc),a4
	adda.w d1,a4
	move.l a4,34(a0)
	move.b 1(a3),44(a0)
	move.b 2(a3),22(a0)
	lea $4a(a0),a0		;Point to next voice's data area
	dbf d6,initloop3
	rts
	
	
PLAY:
	lea audtemp(pc),a5
	tst.w 8(a5)
	bne.s music_on
	rts
music_on:
	subq.w #1,4(a5)			;Decrease replayspeed counter
	bne.s nonewnote
	move.w 6(a5),4(a5)		;Restore replayspeed counter
	moveq #0,d5
	moveq #6,d6
	lea V1data(pc),a0		;Point to voice1 data area
	bsr.W new_note
	lea V2data(pc),a0		;Point to voice2 data area
	bsr.W new_note
	lea V3data(pc),a0		;Point to voice3 data area
	bsr.W new_note
	lea V4data(pc),a0		;Point to voice4 data area
	bsr.W new_note
nonewnote:
	clr.w (a5)
	lea $dff000,a6
	lea V1data(pc),a0
	bsr.W effects
	move.l d0,$a6(a6)
	lea V2data(pc),a0
	bsr.W effects
	move.l d0,$b6(a6)
	lea V3data(pc),a0
	bsr.W effects
	move.l d0,$c6(a6)
	lea V4data(pc),a0
	bsr.W effects
	move.l d0,$d6(a6)
	lea V1data(pc),a0
	move.l 68+[0*74](a0),a1		;Get samplepointer
	adda.w 64+[0*74](a0),a1		;add repeat_start
	move.l 68+[1*74](a0),a2
	adda.w 64+[1*74](a0),a2
	move.l 68+[2*74](a0),a3
	adda.w 64+[2*74](a0),a3
	move.l 68+[3*74](a0),a4
	adda.w 64+[3*74](a0),a4
	move.w 66+[0*74](a0),d1		;Get repeat_length
	move.w 66+[1*74](a0),d2
	move.w 66+[2*74](a0),d3
	move.w 66+[3*74](a0),d4
	moveq #2,d0
	moveq #0,d5
	move.w (a5),d7
	ori.w #$8000,d7			;Set/clr bit = 1
	move.w d7,$dff096		;Enable audio DMA
chan1:
	lea V1data+72(pc),a0
	move.w (a0),d7
	beq.s chan2
	subq.w #1,(a0)
	cmp.w d0,d7
	bne.s chan2
	move.w d5,(a0)
	move.l a1,$a0(a6)		;Set samplestart
	move.w d1,$a4(a6)		;Set samplelength
chan2:
	lea V2data+72(pc),a0
	move.w (a0),d7
	beq.s chan3
	subq.w #1,(a0)
	cmp.w d0,d7
	bne.s chan3
	move.w d5,(a0)
	move.l a2,$b0(a6)
	move.w d2,$b4(a6)
chan3:
	lea V3data+72(pc),a0
	move.w (a0),d7
	beq.s chan4
	subq.w #1,(a0)
	cmp.w d0,d7
	bne.s chan4
	move.w d5,(a0)
	move.l a3,$c0(a6)
	move.w d3,$c4(a6)
chan4:
	lea V4data+72(pc),a0
	move.w (a0),d7
	beq.s endplay
	subq.w #1,(a0)
	cmp.w d0,d7
	bne.s endplay
	move.w d5,(a0)
	move.l a4,$d0(a6)
	move.w d4,$d4(a6)
endplay:
	rts

NEW_NOTE:
	move.l 34(a0),a1
	adda.w 40(a0),a1
	cmp.b #$49,(a1)		;Check "END" mark in pattern
	beq.s patend
	cmp.w #64,40(a0)		;Have all the notes been played?
	bne.L samepat
patend:
	move.w d5,40(a0)
	move.l (a0),a2
	adda.w 6(a0),a2		;Point to next sequence row
	cmpa.l 52(a0),a2	;Is it the end?
	bne.s notend
	move.w d5,6(a0)		;yes!
	move.l (a0),a2		;Point to first sequence
notend:
	lea spdtemp(pc),a3
	moveq #1,d1
	addq.b #1,(a3)
	cmpi.b #5,(a3)
	bne.s nonewspd
	move.b d1,(a3)
	move.b 12(a2),d1	;Get new replay speed
	beq.s nonewspd
	move.w d1,2(a3)		;store in counter
	move.w d1,4(a3)
nonewspd:
	move.b (a2)+,d1		;Pattern to play
	move.b (a2)+,44(a0)	;Transpose value
	move.b (a2)+,22(a0)	;Soundtranspose value
	lsl.w d6,d1
	move.l PATpoint(pc),a1	;Get pattern pointer
	add.w d1,a1
	move.l a1,34(a0)
	addi.w #$000d,6(a0)
samepat:
	move.b 1(a1),d1		;Get info byte
	move.b (a1)+,d0		;Get note
	bne.s ww1
	andi.w #%11000000,d1
	beq.s noport
	bra.s ww11
ww1:
	move.w d5,56(a0)
ww11:
	move.b d5,47(a0)
	btst #7,d1
	beq.s noport
	move.b 2(a1),47(a0)	
noport:
	andi.w #$007f,d0
	beq.L nextnote
	move.b d0,8(a0)
	move.b (a1),d1
	move.b d1,9(a0)
	move.w 32(a0),d3
	or.w d3,(a5)
	move.w d3,$dff096
	andi.w #$003f,d1	;Max 64 instruments
	add.b 22(a0),d1		;add Soundtranspose
	move.l VOLpoint(pc),a2
	lsl.w d6,d1
	adda.w d1,a2
	move.w d5,16(a0)
	move.b (a2),23(a0)
	move.b (a2)+,24(a0)
	moveq #0,d1
	move.b (a2)+,d1
	move.b (a2)+,27(a0)
	move.b #$40,46(a0)
	move.b (a2),28(a0)
	move.b (a2)+,29(a0)
	move.b (a2)+,30(a0)
	move.l a2,10(a0)
	move.l FRQpoint(pc),a2
	lsl.w d6,d1
	adda.w d1,a2
	move.l a2,18(a0)
	move.w d5,50(a0)
	move.b d5,25(a0)
	move.b d5,26(a0)
nextnote:
	addq.w #2,40(a0)
	rts
	
EFFECTS:
	moveq #0,d7
testsustain:
	tst.b 26(a0)		;Is sustain counter = 0
	beq.s sustzero
	subq.b #1,26(a0)	;if no, decrease counter
	bra.W VOLUfx
sustzero:		;Next part of effect sequence
	move.l 18(a0),a1	;can be executed now.
	adda.w 50(a0),a1
testeffects:
	cmpi.b #$e1,(a1)	;E1 = end of FREQseq sequence
	beq.L VOLUfx
	move.b (a1),d0
	cmpi.b #$e0,d0		;E0 = loop to other part of sequence
	bne.s testnewsound
	move.b 1(a1),d1		;loop to start of sequence + 1(a1)
	andi.w #$003f,d1
	move.w d1,50(a0)
	move.l 18(a0),a1
	adda.w d1,a1
	move.b (a1),d0
testnewsound:
	cmpi.b #$e2,d0		;E2 = set waveform
	bne.s testE4
	move.w 32(a0),d1
	or.w d1,(a5)
	move.w d1,$dff096
	moveq #0,d0
	move.b 1(a1),d0
	lea SOUNDINFO(pc),a4
	lsl.w #4,d0
	adda.w d0,a4
	move.l 60(a0),a3
	move.l (a4)+,d1
	move.l d1,(a3)
	move.l d1,68(a0)
	move.w (a4)+,4(a3)
	move.l (a4),64(a0)
	move.w #$0003,72(a0)
	move.w d7,16(a0)
	move.b #$01,23(a0)
	addq.w #2,50(a0)
	bra.W transpose
testE4:
	cmpi.b #$e4,d0
	bne.s testE9
	moveq #0,d0
	move.b 1(a1),d0
	lea SOUNDINFO(pc),a4
	lsl.w #4,d0
	adda.w d0,a4
	move.l 60(a0),a3
	move.l (a4)+,d1
	move.l d1,(a3)
	move.l d1,68(a0)
	move.w (a4)+,4(a3)
	move.l (a4),64(a0)
	move.w #$0003,72(a0)
	addq.w #2,50(a0)
	bra.W transpose
testE9:
	cmpi.b #$e9,d0
	bne testpatjmp
	move.w 32(a0),d1
	or.w d1,(a5)
	move.w d1,$dff096
	moveq #0,d0
	move.b 1(a1),d0
	lea SOUNDINFO(pc),a4
	lsl.w #4,d0
	adda.w d0,a4
	move.l (a4),a2
	cmpi.l #"SSMP",(a2)+
	bne.s nossmp
	lea 320(a2),a4
	moveq #0,d1
	move.b 2(a1),d1
	lsl.w #4,d1
	add.w d1,a2
	add.l (a2),a4
	move.l 60(a0),a3
	move.l a4,(a3)
	move.l 4(a2),4(a3)
	move.l a4,68(a0)
	move.l 6(a2),64(a0)
	move.w d7,16(a0)
	move.b #1,23(a0)
	move.w #3,72(a0)
nossmp:
	addq.w #3,50(a0)
	bra.s transpose
testpatjmp:
	cmpi.b #$e7,d0
	bne.s testpitchbend
	moveq #0,d0
	move.b 1(a1),d0
	lsl.w d6,d0
	move.l FRQpoint(pc),a1
	adda.w d0,a1
	move.l a1,18(a0)
	move.w d7,50(a0)
	bra.W testeffects
testpitchbend:
	cmpi.b #$ea,d0
	bne.s testnewsustain
	move.b 1(a1),4(a0)
	move.b 2(a1),5(a0)
	addq.w #3,50(a0)
	bra.s transpose
testnewsustain:
	cmpi.b #$e8,d0
	bne.s testnewvib
	move.b 1(a1),26(a0)
	addq.w #2,50(a0)
	bra.W testsustain
testnewvib:
	cmpi.b #$e3,(a1)+
	bne.s transpose
	addq.w #3,50(a0)
	move.b (a1)+,27(a0)
	move.b (a1),28(a0)
transpose:
	move.l 18(a0),a1
	adda.w 50(a0),a1
	move.b (a1),43(a0)
	addq.w #1,50(a0)
VOLUfx:	tst.b 25(a0)
	beq.s volsustzero
	subq.b #1,25(a0)
	bra.W calcperiod
	volsustzero:
	tst.b 15(a0)
	bne.s do_VOLbend
	subq.b #1,23(a0)
	bne.s calcperiod
	move.b 24(a0),23(a0)
volu_cmd:
	move.l 10(a0),a1
	adda.w 16(a0),a1
	move.b (a1),d0
testvoluend:
	cmpi.b #$e1,d0
	beq.s calcperiod
	cmpi.b #$ea,d0
	bne.s testVOLsustain
	move.b 1(a1),14(a0)
	move.b 2(a1),15(a0)
	addq.w #3,16(a0)
	bra.s do_VOLbend
testVOLsustain:
	cmpi.b #$e8,d0
	bne.s testVOLloop
	addq.w #2,16(a0)
	move.b 1(a1),25(a0)
	bra.s calcperiod
testVOLloop:
	cmpi.b #$e0,d0
	bne.s setvolume
	move.b 1(a1),d0
	andi.w #$003f,d0
	subq.b #5,d0
	move.w d0,16(a0)
	bra.s volu_cmd
do_VOLbend:
	not.b 38(a0)
	beq.s calcperiod
	subq.b #1,15(a0)
	move.b 14(a0),d1
	add.b d1,45(a0)
	bpl.s calcperiod
	moveq #0,d1
	move.b d1,15(a0)
	move.b d1,45(a0)
	bra.s calcperiod
setvolume:
	move.b (a1),45(a0)
	addq.w #1,16(a0)
calcperiod:
	move.b 43(a0),d0
	bmi.s lockednote
	add.b 8(a0),d0
	add.b 44(a0),d0
lockednote:
	moveq #$7f,d1
	and.l d1,d0
	lea PERIODS(pc),a1
	add.w d0,d0
	move.w d0,d1
	adda.w d0,a1
	move.w (a1),d0

	move.b 46(a0),d7
	tst.b 30(a0)		;Vibrato_delay = zero ?
	beq.s vibrator
	subq.b #1,30(a0)
	bra.s novibrato
vibrator:
	moveq #5,d2
	move.b d1,d5
	move.b 28(a0),d4
	add.b d4,d4
	move.b 29(a0),d1
	tst.b d7
	bpl.s vib1
	btst #0,d7
	bne.s vib4
vib1:	btst d2,d7
	bne.s vib2
	sub.b 27(a0),d1
	bcc.s vib3
	bset d2,d7
	moveq #0,d1
	bra.s vib3
vib2:	add.b 27(a0),d1
	cmp.b d4,d1
	bcs.s vib3
	bclr d2,d7
	move.b d4,d1
vib3:	move.b d1,29(a0)
vib4:	lsr.b #1,d4
	sub.b d4,d1
	bcc.s vib5
	subi.w #$0100,d1
vib5:	addi.b #$a0,d5
	bcs.s vib7
vib6:	add.w d1,d1
	addi.b #$18,d5
	bcc.s vib6
vib7:
	add.w d1,d0
novibrato:
	eori.b #$01,d7
	move.b d7,46(a0)

; DO THE PORTAMENTO THING
	not.b 39(a0)
	beq.s pitchbend
	moveq #0,d1
	move.b 47(a0),d1	;get portavalue
	beq.s pitchbend		;0=no portamento
	cmpi.b #$1f,d1
	bls.s portaup
portadown: 
	andi.w #$1f,d1
	neg.w d1
portaup:sub.w d1,56(a0)
pitchbend:
	not.b 42(a0)
	beq.s addporta
	tst.b 5(a0)
	beq.s addporta
	subq.b #1,5(a0)
	moveq #0,d1
	move.b 4(a0),d1
	bpl.s pitchup
	ext.w d1
pitchup:sub.w d1,56(a0)
addporta:
	add.w 56(a0),d0
	cmpi.w #$0070,d0
	bhi.s nn1
	move.w #$0071,d0
nn1:	cmpi.w #$0d60,d0
	bls.s nn2
	move.w #$0d60,d0
nn2:	swap d0
	move.b 45(a0),d0
	rts

V1data:  blk.b 64,0	;Voice 1 data area
offset1: blk.b 02,0	;Is added to start of sound
ssize1:  blk.b 02,0	;Length of sound
start1:  blk.b 06,0	;Start of sound

V2data:  blk.b 64,0	;Voice 2 data area
offset2: blk.b 02,0
ssize2:  blk.b 02,0
start2:  blk.b 06,0

V3data:  blk.b 64,0	;Voice 3 data area
offset3: blk.b 02,0
ssize3:  blk.b 02,0
start3:  blk.b 06,0

V4data:  blk.b 64,0	;Voice 4 data area
offset4: blk.b 02,0
ssize4:  blk.b 02,0
start4:  blk.b 06,0

audtemp: dc.w 0		;DMACON
spdtemp: dc.w 0
respcnt: dc.w 0		;Replay speed counter 
repspd:  dc.w 0		;Replay speed counter temp
onoff:   dc.w 0		;Music on/off flag.

Chandata: dc.l $00000000,$00100003,$00200006,$00300009
SEQpoint: dc.l 0
PATpoint: dc.l 0
FRQpoint: dc.l 0
VOLpoint: dc.l 0


SILENT: dc.w $0100,$0000,$0000,$00e1

PERIODS:dc.w $06b0,$0650,$05f4,$05a0,$054c,$0500,$04b8,$0474
	dc.w $0434,$03f8,$03c0,$038a,$0358,$0328,$02fa,$02d0
	dc.w $02a6,$0280,$025c,$023a,$021a,$01fc,$01e0,$01c5
	dc.w $01ac,$0194,$017d,$0168,$0153,$0140,$012e,$011d
	dc.w $010d,$00fe,$00f0,$00e2,$00d6,$00ca,$00be,$00b4
	dc.w $00aa,$00a0,$0097,$008f,$0087,$007f,$0078,$0071
	dc.w $0071,$0071,$0071,$0071,$0071,$0071,$0071,$0071
	dc.w $0071,$0071,$0071,$0071,$0d60,$0ca0,$0be8,$0b40
	dc.w $0a98,$0a00,$0970,$08e8,$0868,$07f0,$0780,$0714
	dc.w $1ac0,$1940,$17d0,$1680,$1530,$1400,$12e0,$11d0
	dc.w $10d0,$0fe0,$0f00,$0e28,$06b0,$0650,$05f4,$05a0
	dc.w $054c,$0500,$04b8,$0474,$0434,$03f8,$03c0,$038a
	dc.w $0358,$0328,$02fa,$02d0,$02a6,$0280,$025c,$023a
	dc.w $021a,$01fc,$01e0,$01c5,$01ac,$0194,$017d,$0168
	dc.w $0153,$0140,$012e,$011d,$010d,$00fe,$00f0,$00e2
	dc.w $00d6,$00ca,$00be,$00b4,$00aa,$00a0,$0097,$008f
	dc.w $0087,$007f,$0078,$0071

SOUNDINFO:
;Start.l , Length.w , Repeat start.w , Repeat-length.w , blk.b 6,0 

	blk.b 10*16,0	;Reserved for samples
	blk.b 80*16,0	;Reserved for waveform
modul:	incbin	"fc14.classic"

introout:
	
